﻿using System.CommandLine;
using MycroForge.CLI;
using MycroForge.CLI.CodeGen;
using MycroForge.CLI.Exceptions;
using MycroForge.CLI.Extensions;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

using var host = Host
    .CreateDefaultBuilder()
    .ConfigureServices((_, services) =>
    {
        services
            .AddServices(args)
            .AddCommands();
    })
    .Build();

try
{
    var ctx = host.Services.GetRequiredService<ProjectContext>();
    await ctx.LoadConfig();
    await host.Services.GetRequiredService<MycroForge.CLI.Commands.MycroForge>().InvokeAsync(args);
    await ctx.SaveConfig();
}
catch
{
    // Console.WriteLine(e.Message);
}

// var src = new OrmEnvInitializer(await File.ReadAllTextAsync("scripts/env.py")).Rewrite();
// Console.WriteLine(src);